boolean focus_offsetM1_old;
boolean focus_offsetM2_old;
boolean focus_Kp_old;
boolean focus_Ki_old;
boolean focus_Kd_old;
boolean focus_pwmMax_old;
boolean focus_speedRamp_old;

void slider_release() {                        // send slider values to Arduino at slider release

  if(! slider_offsetM1.hasFocus() && focus_offsetM1_old) { sendCommand('M', offsetM1_val); }
    focus_offsetM1_old = slider_offsetM1.hasFocus();
  if(! slider_offsetM2.hasFocus() && focus_offsetM2_old) { sendCommand('N', offsetM2_val); }
    focus_offsetM2_old = slider_offsetM2.hasFocus();
  if(! slider_Kp.hasFocus() && focus_Kp_old) { sendCommand('R', kp_val); }
    focus_Kp_old = slider_Kp.hasFocus();
  if(! slider_Ki.hasFocus() && focus_Ki_old) { sendCommand('S', ki_val); }
    focus_Ki_old = slider_Ki.hasFocus();
  if(! slider_Kd.hasFocus() && focus_Kd_old) { sendCommand('T', kd_val); }
    focus_Kd_old = slider_Kd.hasFocus();
  if(! slider_pwmMax.hasFocus() && focus_pwmMax_old) { sendCommand('P', pwm_max_val); }
    focus_pwmMax_old = slider_pwmMax.hasFocus();
  if(! slider_speedRamp.hasFocus() && focus_speedRamp_old) { sendCommand('V', speed_ramp_val); }
    focus_speedRamp_old = slider_speedRamp.hasFocus();
}

//**********************************************

void enable_simtools() {             // enable simtools handles
  imgTogButton_sim.setVisible(true);
  imgTogButton_sim.setState(0);
}

//**********************************************

void disable_simtools() {            // disable simtools handles
  imgTogButton_sim.setVisible(false);
  imgTogButton_sim.setState(0);
}

//**********************************************

void enable_manual() {               // enable manual handles
  slider_manual1.setVisible(true);
  slider_manual2.setVisible(true);
  slider2d_manual.setVisible(true);
  button_manZero.setVisible(true);
}

//************************************************

void disable_manual() {              // disable manual handles
  slider2d_manual.setValueXY(0, 0);
  slider_manual1.setValue(0);
  slider_manual2.setValue(0);
  slider_manual1.setVisible(false);
  slider_manual2.setVisible(false);
  slider2d_manual.setVisible(false);
  button_manZero.setVisible(false);
}

//************************************************

void enable_curve() {                // enable curve handles
  knob_frequency.setVisible(true);
  label_frequency.setVisible(true);
  knob_level.setVisible(true);
  label_level.setVisible(true);
  option_sine.setVisible(true);
  option_square.setVisible(true);
  button_startWave.setVisible(true);
  button_stopWave.setVisible(true);
}

//************************************************

void disable_curve() {                // disable curve handles
  knob_frequency.setVisible(false);
  label_frequency.setVisible(false);
  knob_level.setVisible(false);
  label_level.setVisible(false);
  option_sine.setVisible(false);
  option_square.setVisible(false);
  button_startWave.setVisible(false);
  button_stopWave.setVisible(false);
}